<?php
/*
  $Id: ht_store_mode.php
  $Loc: catalog/includes/modules/header_tags/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  2016 Store Mode 1.3.2
  by @raiwa 
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019, Rainer Schmied
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class ht_store_mode {
    var $code = 'ht_store_mode';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_HEADER_TAGS_STORE_MODE_TITLE;
      $this->description = MODULE_HEADER_TAGS_STORE_MODE_DESCRIPTION;

      if (!defined('MODULE_CONTENT_HEADER_STORE_MODE_STATUS') || defined('MODULE_CONTENT_HEADER_STORE_MODE_STATUS') && MODULE_CONTENT_HEADER_STORE_MODE_STATUS != 'True' ) {
        $this->description = '<div class="secWarning">' . 
                                 MODULE_HEADER_TAGS_STORE_MODE_HEADER_MODULE_WARNING . 
                             '  <a href="modules_content.php?module=cm_header_store_mode&action=install">' . MODULE_HEADER_TAGS_STORE_MODE_HEADER_MODULE_INSTALL_NOW . '</a>
                             </div>' . 
                             $this->description;
      }      
      
      if ( defined('MODULE_HEADER_TAGS_STORE_MODE_STATUS') ) {
        $this->sort_order = MODULE_HEADER_TAGS_STORE_MODE_SORT_ORDER;
        $this->enabled = (MODULE_HEADER_TAGS_STORE_MODE_STATUS == 'true');
      }
    }

    function execute() {
      global $PHP_SELF, $oscTemplate, $navigation, $_SESSION, $messageStack;
      
      $allowed_ips_array = array();
      $allowed_ips_array = explode(',', MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS);          
          
      if ( MODULE_HEADER_TAGS_STORE_MODE != 'online' && (!in_array(getenv('REMOTE_ADDR'), $allowed_ips_array) || strpos(MODULE_HEADER_TAGS_STORE_MODE, '-test') > 0) ) {
        
        $store_mode = str_replace('-test', '', MODULE_HEADER_TAGS_STORE_MODE);
        
        switch ($store_mode) {
          
          case 'custom' :
          $custom_pages_array = array();
          foreach (explode(';', MODULE_HEADER_TAGS_STORE_MODE_CUSTOM_PAGES) as $custompage) {
            $custompage = trim($custompage);
            if (!empty($custompage)) {
              $custom_pages_array[] = $custompage;
            }
          }
          $this->store_mode_redirect($custom_pages_array, 'index.php');
          break;
          
          case 'checkout' :
          $checkout_pages_array = array();
          foreach (explode(';', MODULE_HEADER_TAGS_STORE_MODE_CHECKOUT_PAGES) as $checkoutpage) {
            $checkoutpage = trim($checkoutpage);
            if (!empty($checkoutpage)) {
              $checkout_pages_array[] = $checkoutpage;
            }
          }
          $this->store_mode_redirect($checkout_pages_array, 'index.php');
          break;
          
          case 'account' :
          $account_pages_array = array();
          $account_pages = MODULE_HEADER_TAGS_STORE_MODE_LOGIN_ACCOUNT_PAGES . MODULE_HEADER_TAGS_STORE_MODE_CHECKOUT_PAGES;
          foreach (array_unique(explode(';', $account_pages)) as $accountpage) {
            $accountpage = trim($accountpage);
            if (!empty($accountpage)) {
              $account_pages_array[] = $accountpage;
            }
          }
          $this->store_mode_redirect($account_pages_array, 'shopping_cart');
          break;
        }
        
        // logg customer out
        if ( tep_session_is_registered('customer_id') && MODULE_HEADER_TAGS_STORE_MODE_LOGOFF == 'true' ) {
          tep_session_unregister('customer_default_address_id');
          tep_session_unregister('customer_first_name');
          tep_session_unregister('customer_country_id');
          tep_session_unregister('customer_zone_id');
          tep_session_unregister('customer_id');
          $messageStack->add_session('store_mode', MODULE_HEADER_TAGS_STORE_MODE_ACCOUNT_LOGGED_OFF . '<br><br>' . $this->get_offline_time(), 'alert');
        }

      } // end if mode != online
      
    } // end execute

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_HEADER_TAGS_STORE_MODE_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Current Version', 'MODULE_HEADER_TAGS_STORE_MODE_VERSION_INSTALLED', 'Version 1.3.0.', 'Version info. It is read only.', '6', '1', 'tep_version_readonly(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Store Mode Module', 'MODULE_HEADER_TAGS_STORE_MODE_STATUS', 'true', 'Do you want to add the Store Mode Module to your shop?', '6', '2', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Store Mode', 'MODULE_HEADER_TAGS_STORE_MODE', 'online', 'Test Modes: Only allowed IPs will be redirected.', '6', '3', 'ht_store_mode_add_to_htaccess', 'tep_cfg_select_option(array(\'online\', \'custom\', \'custom-test\', \'checkout\', \'checkout-test\', \'account\', \'account-test\', \'offline\', \'offline-test\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Logoff customers', 'MODULE_HEADER_TAGS_STORE_MODE_LOGOFF', 'false', 'Do you want to logoff customers? Applies on all modes except online.', '6', '4', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Show back time', 'MODULE_HEADER_TAGS_STORE_MODE_SHOW_BACK_TIME', 'true', 'Do you want to show the back time message? Applies to the maintenance page shown in offline mode.', '6', '5', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Back hour', 'MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME', '0:00', 'The hour when the store will be back online.<br>Format: \"hh:mm\", Example: 19:30.<br> Leave empty to automatically set 2 h ahead from the current time when disconnected.<br>Limit: 24 h, next day\'s time will show correct.<br>Leave empty to disable this message part.', '6', '6', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Allowed IPs', 'MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS', '" . getenv('REMOTE_ADDR') . "', 'List of allowed IPs to access the store if in Closed or Maintenance Mode?<br>Coma separated list. Format: 000.000.000.000,000.000.000.000.', '6', '8', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Custom Pages', 'MODULE_HEADER_TAGS_STORE_MODE_CUSTOM_PAGES', '" . implode(';', $this->get_default_pages_custom()) . "', 'The custom pages to disallow.', '6', '9', 'ht_store_mode_show_pages', 'ht_store_mode_custom_edit_pages(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Checkout Pages', 'MODULE_HEADER_TAGS_STORE_MODE_CHECKOUT_PAGES', '" . implode(';', $this->get_default_pages_checkout()) . "', 'The checkout pages to disallow.', '6', '10', 'ht_store_mode_show_pages', 'ht_store_mode_checkout_edit_pages(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Login Account Pages', 'MODULE_HEADER_TAGS_STORE_MODE_LOGIN_ACCOUNT_PAGES', '" . implode(';', $this->get_default_pages_account()) . "', 'The login and account pages to disallow.', '6', '11', 'ht_store_mode_show_pages', 'ht_store_mode_account_edit_pages(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_STORE_MODE_SORT_ORDER', '0', 'Sort order of display. Must be first, readonly.', '6', '12', 'tep_sort_order_readonly(', now())");

      if (!class_exists('language')) include('includes/classes/language.php');
      $lng = new language;
       foreach($lng->catalog_languages as $key => $value) { 
      	$key = strtoupper($value['directory']);
        switch ($key) {
        	case 'ESPANOL':        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mensaje para admins " . $key . "', 'MODULE_HEADER_TAGS_STORE_MODE_MESSAGE_" . $key . "', 'La tienda está en modo %s. No olvide volver a ponerla en Modo Online cuando haya terminado.<br>El mensaje de tiempo para volver Online mostrada es \"%s\".', 'Mensaje que se muestra a Administradores cuando la tienda no está en Modo Online en idioma " . $key . "', '6', '13', now())");
        		break;
        	case 'GERMAN':        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mitteilung für Admins " . $key . "', 'MODULE_HEADER_TAGS_STORE_MODE_MESSAGE_" . $key . "', 'Der Shop befindet sich im %s Modus. Vergessen Sie nicht ihn wieder auf Online Modus zu schalten wenn Sie fertig sind.<br>Die angezeigte Online Zeit Mitteilung ist \"%s\".', 'Mitteilung die für Administratoren angezeigt wird wenn der Shop nicht in Online Modus ist in " . $key . " Sprache.', '6', '14', now())");
        		break;
        	default:        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Message for admins " . $key . "', 'MODULE_HEADER_TAGS_STORE_MODE_MESSAGE_" . $key . "', 'The store is actually in %s Mode. Don\'t forget to switch it back to Online Mode once you finished.<br>The time message shown to come back Online is: %s.', 'Message shown to Administrators if the store is not in Online Mode for " . $key . " language.', '6', '15', now())");
        }
      }
      htaccess_backup('master_backup_htaccess_' . date('Y-m-d'));
      
      // add message to admin header
      if ( is_file(DIR_FS_ADMIN . 'includes/header.php') ) {
        $file = file_get_contents(DIR_FS_ADMIN . 'includes/header.php');
        $find_file = '  if ($messageStack->size > 0) {';
        $replace_file = '// Store Mode BEGIN' . "\n" . 
                        '  if (defined(\'MODULE_HEADER_TAGS_STORE_MODE\') && MODULE_HEADER_TAGS_STORE_MODE != \'online\') {' . "\n" . 
                        '    $messageStack->add(sprintf(constant(\'MODULE_HEADER_TAGS_STORE_MODE_MESSAGE_\' . strtoupper($language)), strtoupper(MODULE_HEADER_TAGS_STORE_MODE), MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME));' . "\n" . 
                        '  }' . "\n" . 
                        '// Store Mode END' . "\n\n" . 
                        $find_file;

        $file = str_replace($find_file, $replace_file, $file);
        file_put_contents(DIR_FS_ADMIN . 'includes/header.php', $file);
      }
        
      // customize maintenance.php
      if ( is_file(DIR_FS_CATALOG . 'maintenance.php') ) {
        $file = file_get_contents(DIR_FS_CATALOG . 'maintenance.php');
      // add store name
        $store_name_esc = str_replace('\'', '\\\'', STORE_NAME);
        $file = preg_replace('%define\(\'TEXT_STORE_NAME\', \'(.*)\'\);%', 'define(\'TEXT_STORE_NAME\', \'' . $store_name_esc . '\');', $file);
      // add store mail
        $file = preg_replace('%\$store_mail = \'(.*)\';%', '\$store_mail = \'' . STORE_OWNER_EMAIL_ADDRESS . '\';', $file);
        file_put_contents(DIR_FS_CATALOG . 'maintenance.php', $file);
      }
    }    
    
    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
      // remove rewrite rules
      $file = file_get_contents(DIR_FS_CATALOG . '.htaccess');
      if ( strpos($file, 'RewriteRule .* maintenance.php? [R=307,L]') > 0 ) {
        $file = preg_replace('@#Store Mode Begin((?:.|[\r\n])+?)#Store Mode End\n\n@', '', $file);
        file_put_contents(DIR_FS_CATALOG . '.htaccess', $file);
      }

      // remove message from admin header
      if ( is_file(DIR_FS_ADMIN . 'includes/header.php') ) {
        $file = file_get_contents(DIR_FS_ADMIN . 'includes/header.php');
        if ( strpos($file, '// Store Mode BEGIN') > 0 ) {
          $find_file = '// Store Mode BEGIN' . "\n" . 
                        '  if (defined(\'MODULE_HEADER_TAGS_STORE_MODE\') && MODULE_HEADER_TAGS_STORE_MODE != \'online\') {' . "\n" . 
                        '    $messageStack->add(sprintf(constant(\'MODULE_HEADER_TAGS_STORE_MODE_MESSAGE_\' . strtoupper($language)), strtoupper(MODULE_HEADER_TAGS_STORE_MODE), MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME));' . "\n" . 
                        '  }' . "\n" . 
                        '// Store Mode END' . "\n\n";

        $file = str_replace($find_file, '', $file);
        file_put_contents(DIR_FS_ADMIN . 'includes/header.php', $file);
        }
      }
    }

    function keys() {
      $KeysArray = array('MODULE_HEADER_TAGS_STORE_MODE_VERSION_INSTALLED', 'MODULE_HEADER_TAGS_STORE_MODE_STATUS', 'MODULE_HEADER_TAGS_STORE_MODE', 'MODULE_HEADER_TAGS_STORE_MODE_LOGOFF', 'MODULE_HEADER_TAGS_STORE_MODE_SHOW_BACK_TIME', 'MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME', 'MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS', 'MODULE_HEADER_TAGS_STORE_MODE_CUSTOM_PAGES', 'MODULE_HEADER_TAGS_STORE_MODE_CHECKOUT_PAGES', 'MODULE_HEADER_TAGS_STORE_MODE_LOGIN_ACCOUNT_PAGES', 'MODULE_HEADER_TAGS_STORE_MODE_SORT_ORDER');
      include_once('includes/classes/language.php');
      $lng = new language;
       foreach($lng->catalog_languages as $key => $value) { 
      	$key = strtoupper($value['directory']);
      	$KeysArray[] = 'MODULE_HEADER_TAGS_STORE_MODE_MESSAGE_' . $key;
      }
      return $KeysArray;
    }
    
    function get_default_pages_custom() {
      return array('product_reviews.php',
                   'product_reviews_write.php');
    }

    function get_default_pages_checkout() {
      return array('checkout_shipping.php',
                   'checkout_shipping_address.php',
                   'checkout_payment.php',
                   'checkout_payment_address.php',
                   'checkout_confirmation.php',
                   'checkout_process.php');
    }

    function get_default_pages_account() {
      return array('login.php',
                   'create_account.php',
                   'account.php',
                   'account_edit.php',
                   'account_history.php',
                   'account_history_info.php',
                   'account_newsletters.php',
                   'account_notifications.php',
                   'account_password.php',
                   'address_book.php',
                   'address_book_process.php',
                   'password_forgotten.php',
                   'password_reset.php');
    }

// redirect function
    function store_mode_redirect($pages_array, $default_page) {
      global $PHP_SELF, $navigation, $messageStack, $breadcrumb;
      if (in_array(basename($PHP_SELF), $pages_array)) {
        if (in_array($default_page, $pages_array)) $default_page = 'index.php';
        if ( defined('NAVBAR_TITLE_2') && NAVBAR_TITLE_2 !='' ) {
          $page_name = NAVBAR_TITLE_2;
        } elseif ( defined('NAVBAR_TITLE_1') && NAVBAR_TITLE_1 !='' ) {
          $page_name = NAVBAR_TITLE_1;
        } elseif ( defined('NAVBAR_TITLE') && NAVBAR_TITLE !='' ) {
          $page_name = NAVBAR_TITLE;
        } elseif ( defined('HEADER_TITLE') && HEADER_TITLE !='' ) {
          $page_name = NAVBAR_TITLE;
        }
        $messageStack->add_session('store_mode', sprintf(MODULE_HEADER_TAGS_STORE_MODE_REDIRECT_MESSAGE, $page_name) . '<br><br>' . $this->get_offline_time(), 'alert');
        $back = sizeof($navigation->path)-2;
        if (in_array($navigation->path[$back]['page'], $pages_array) ) {
          $back = sizeof($navigation->path)-3;
        } 
        if (in_array($navigation->path[$back]['page'], $pages_array) ) {
          $back = sizeof($navigation->path)-4;
        }
        if (isset($navigation->path[$back])) {
          tep_redirect(tep_href_link($navigation->path[$back]['page'], tep_array_to_string($navigation->path[$back]['get'], array('action')), $navigation->path[$back]['mode']));
        } else {
          tep_redirect(tep_href_link($default_page));
        }
      }
    }

// get offline time left
    private function get_offline_time() {
      if (MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME != '') {
        $to_time = strtotime(date("Y-m-d H:i:s"));
        $from_time = strtotime(date('Y-m-d') . MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME . ':00');
        if ($from_time < $to_time) $from_time += 24 * 60 * 60;
        $time_left = gmdate("H:i", round(abs($to_time - $from_time)));
        return  sprintf(MODULE_HEADER_TAGS_STORE_MODE_ACCOUNT_REOPEN_TIME, $time_left);
      }
    }
    
  } // end class
  
  function ht_store_mode_show_pages($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function ht_store_mode_get_pages() {
    global $PHP_SELF;
    $exclude_array = array('maintenance.php',
                           'index.php',
                   				 'download.php',
                   				 'redirect.php',
                   				 'ssl_check.php');
    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG)) {
	    while ($file = $dir->read()) {
    	  if ( !is_dir(DIR_FS_CATALOG . $file) && !in_array($file, $exclude_array) ) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }
    return $files_array;
  }

  function ht_store_mode_custom_edit_pages($values, $key) {
    
    $files_array = ht_store_mode_get_pages();

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('ht_store_mode_custom_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htcu_files"');

    $output .= '<script>
                function htcu_update_cfg_value() {
                  var htcu_selected_files = \'\';

                  if ($(\'input[name="ht_store_mode_custom_file[]"]\').length > 0) {
                    $(\'input[name="ht_store_mode_custom_file[]"]:checked\').each(function() {
                      htcu_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htcu_selected_files.length > 0) {
                      htcu_selected_files = htcu_selected_files.substring(0, htcu_selected_files.length - 1);
                    }
                  }

                  $(\'#htcu_files\').val(htcu_selected_files);
                }

                $(function() {
                  htcu_update_cfg_value();

                  if ($(\'input[name="ht_store_mode_custom_file[]"]\').length > 0) {
                    $(\'input[name="ht_store_mode_custom_file[]"]\').change(function() {
                      htcu_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }

  function ht_store_mode_checkout_edit_pages($values, $key) {
    
    $files_array = ht_store_mode_get_pages();

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('ht_store_mode_checkout_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htco_files"');

    $output .= '<script>
                function htco_update_cfg_value() {
                  var htco_selected_files = \'\';

                  if ($(\'input[name="ht_store_mode_checkout_file[]"]\').length > 0) {
                    $(\'input[name="ht_store_mode_checkout_file[]"]:checked\').each(function() {
                      htco_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htco_selected_files.length > 0) {
                      htco_selected_files = htco_selected_files.substring(0, htco_selected_files.length - 1);
                    }
                  }

                  $(\'#htco_files\').val(htco_selected_files);
                }

                $(function() {
                  htco_update_cfg_value();

                  if ($(\'input[name="ht_store_mode_checkout_file[]"]\').length > 0) {
                    $(\'input[name="ht_store_mode_checkout_file[]"]\').change(function() {
                      htco_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
  
  function ht_store_mode_account_edit_pages($values, $key) {

    $files_array = ht_store_mode_get_pages();

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('ht_store_mode_account_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htac_files"');

    $output .= '<script>
                function htac_update_cfg_value() {
                  var htac_selected_files = \'\';

                  if ($(\'input[name="ht_store_mode_account_file[]"]\').length > 0) {
                    $(\'input[name="ht_store_mode_account_file[]"]:checked\').each(function() {
                      htac_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htac_selected_files.length > 0) {
                      htac_selected_files = htac_selected_files.substring(0, htac_selected_files.length - 1);
                    }
                  }

                  $(\'#htac_files\').val(htac_selected_files);
                }

                $(function() {
                  htac_update_cfg_value();

                  if ($(\'input[name="ht_store_mode_account_file[]"]\').length > 0) {
                    $(\'input[name="ht_store_mode_account_file[]"]\').change(function() {
                      htac_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
  
  function ht_store_mode_add_to_htaccess($mode_text) {
    if ( isset($_GET['module']) && $_GET['module'] == 'ht_store_mode') {
      // update the allowed IPs list
      $allowed_ips_array = array();
      $offline_rewrite = null;
      $allowed_ips_array = explode(',', MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS);          
      if (!in_array(getenv('REMOTE_ADDR'), $allowed_ips_array)) {
        $ip_list = getenv('REMOTE_ADDR') . ',' . MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS;
        tep_db_query("update `configuration` set `configuration_value` =  '" . $ip_list . "' where `configuration_key` = 'MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS'");
        $allowed_ips_array = explode(',', $ip_list);          
      }
      // define the .htaccess rewrite rules
      $back_time = '';
      if (MODULE_HEADER_TAGS_STORE_MODE_SHOW_BACK_TIME != 'false' ) {
        if (MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME != '') {
          $back_time = '?back_time=' . MODULE_HEADER_TAGS_STORE_MODE_BACK_TIME;
        } else {
          $back_time = '?back_time=' . date('H:i', strtotime('now +2 hour'));
        }
      }
      if ( strpos(MODULE_HEADER_TAGS_STORE_MODE, 'offline') > -1 ) {
        $offline_rewrite = '#Store Mode Begin' . "\n" . 
                           '<IfModule mod_rewrite.c>' . "\n" . 
                           ' RewriteEngine on'  . "\n" . 
                           ' RewriteBase ' . ((getenv('HTTPS') == 'on')? DIR_WS_CATALOG : DIR_WS_HTTPS_CATALOG) . "\n" .
                           ' RewriteRule ^' . ((getenv('HTTPS') == 'on')? str_replace(DIR_WS_CATALOG, '', DIR_WS_ADMIN) : str_replace(DIR_WS_HTTPS_CATALOG, '', DIR_WS_HTTPS_ADMIN)) . ' - [L,NC]' . "\n";
        $i = null;
        foreach ($allowed_ips_array as $ip) {
          if (MODULE_HEADER_TAGS_STORE_MODE == 'offline-test') { // define the allowed IPs redirect rules for test mode
            $i++;
            $offline_rewrite .= ' RewriteCond %{REMOTE_ADDR} ^' . str_replace('.', '\.', $ip) . '$' . ($i < sizeof($allowed_ips_array)? '  [OR]' : '') . "\n";
          } elseif (MODULE_HEADER_TAGS_STORE_MODE == 'offline') {// define the allowed IPs exclude redirect rules for normal mode
           $offline_rewrite .= ' RewriteCond %{REMOTE_ADDR} !^' . str_replace('.', '\.', $ip) . '$' . "\n";
          }
        }
        $offline_rewrite .= ' RewriteCond %{REQUEST_URI} !maintenance.php$ [NC]' . "\n" . 
                            ' RewriteCond %{REQUEST_URI} !.(jpe?g?|png|gif|css|js) [NC]' . "\n" . 
                            ' RewriteRule .* maintenance.php' . $back_time. ' [R=307,L]' . "\n" . //VMN                            
                            '</IfModule>' . "\n" . 
                            '#Store Mode End' . "\n\n";
        // update the .htaccess file
        $file = file_get_contents(DIR_FS_CATALOG . '.htaccess');
        if ( strpos($file, 'RewriteRule .* maintenance.php') === false ) {
          htaccess_backup('backup_htaccess');
        } elseif ( strpos($file, 'RewriteRule .* maintenance.php') > 0 ) {
          $file = preg_replace('@#Store Mode Begin((?:.|[\r\n])+?)#Store Mode End\n\n@', '', $file);
        }
        $file = preg_replace('@ExpiresDefault@','#ExpiresDefault',$file);   //VMN
        $content = $offline_rewrite . $file;
        file_put_contents(DIR_FS_CATALOG . '.htaccess', $content);
      } elseif ( (strpos(MODULE_HEADER_TAGS_STORE_MODE, 'offline') === false ) && isset($_GET['module']) && $_GET['module'] == 'ht_store_mode' ) {
        // remove rewrite rules
        $file = file_get_contents(DIR_FS_CATALOG . '.htaccess');
        $file = preg_replace('@#Store Mode Begin((?:.|[\r\n])+?)#Store Mode End\n\n@', '', $file);
        $file = preg_replace('@#ExpiresDefault@','ExpiresDefault',$file);   //VMN
        file_put_contents(DIR_FS_CATALOG . '.htaccess', $file);
      }
    }
    return nl2br(implode("\n", explode(';', $mode_text)));
  }

   // function create htaccess backup  
  function htaccess_backup($bkup_name) {
    $separator = ((substr(DIR_FS_CATALOG, -1) != '/') ? '/' : '');
    $backupDir = DIR_FS_CATALOG . $separator . 'htaccess_backups';
    $backupDir .= '/';

    // create backup dir
    if(!is_dir($backupDir)) mkdir($backupDir, 0755);

    // create .htaccess protection containing allowed ip's
    $htaccessfile = $backupDir . '.htaccess';
    $htaccess = '';
    if ( defined('MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS ') && tep_not_null(MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS) ) {
      $allowed_ips_array = explode(',', MODULE_HEADER_TAGS_STORE_MODE_ALLOWED_IPS);
      foreach ($allowed_ips_array as $ip) {
        $htaccess .= 'Require ip ' . $ip . "\n";
      }
    }
    file_put_contents($htaccessfile, $htaccess);

    $htaccessfileOrig = DIR_FS_CATALOG . $separator . '.htaccess';
    $htaccessfileBkup = $backupDir . $bkup_name;

    $result = copy($htaccessfileOrig, $htaccessfileBkup);
} 

// function show the version read only  
  if(!function_exists('tep_version_readonly')) {
  	function tep_version_readonly($value){
  		$version_text = '<br>Version ' . $value;
      return $version_text;
    }
  }
  
// function show the sort order read only  
  if(!function_exists('tep_sort_order_readonly')) {
  	function tep_sort_order_readonly($value){
  		$sort_order_text = '<br>Sort Order ' . $value;
      return $sort_order_text;
    }
  }
  
// function show the logoff internal use only  
  if(!function_exists('tep_logoff_readonly')) {
  	function tep_logoff_readonly($value){
  		$logoff_text = $value;
      return $logoff_text;
    }
  }

?>
